#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

const int mod = 1e9 + 7, K = 7, N = 2e2;
cc_hash_table<int, int> dp[N + 1];
pair<int, int> mp[1 << 21];
vector<int> d[K + 1];
int g[K + 1][K + 1];
int k;

void f(int mask) {
    int ans = 0, sm = 0;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k - i - 1; ++j) {
            if ((mask >> g[i][j]) & 1) {
                ++sm;
                ans ^= (1 << g[i + 1][j]);
            }
        }
    }
    mp[mask] = {ans, sm};
}

void solve() {
    int n;
    cin >> n >> k;
    for (int mask = 0; mask < (1 << k); ++mask) {
        int sm = 0;
        for (int i = 0; i < k; ++i) {
            sm += ((mask >> i) & 1);
        }
        d[sm].emplace_back(mask);
    }
    int sm1 = 0;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j <= k - i - 1; ++j) {
            g[i][j] = sm1++;
        }
    }
    int k1 = k * (k + 1) / 2;
    for (int mask = 0; mask < (1 << k1); ++mask) {
        f(mask);
    }
    dp[0][0] = 1;
    for (int t = 1; t <= n; ++t) {
        int s;
        cin >> s;
        for (auto [mask,kol]: dp[t - 1]) {
            auto [mask1, sm] = mp[mask];
            if (s - sm >= 0 && s - sm <= K) {
                for (auto m: d[s - sm]) {
                    auto it = dp[t].find(mask1 ^ m);
                    if (it == dp[t].end()) {
                        dp[t][mask1 ^ m] = kol;
                    } else {
                        it->second = it->second + kol < mod ? it->second + kol : it->second + kol - mod;
                    }
                }
            }
        }
        dp[t - 1].clear();
    }
    int ans = 0;
    for (auto [mask,kol]: dp[n]) {
        ans = ans + kol < mod ? ans + kol : ans + kol - mod;
    }
    cout << ans;
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
