#include<bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

// #define int long long
using ll = long long;
using ld = long double;
const int N = 1e2, mod = 1e9 + 7;
int dp[N][N][N], n, m;
int dp1[N][N], dp2[N][N];

inline int rec(int x1 = 1, int y1 = 0, int x2 = 0) {
    int y2 = x1 + y1 - x2;
    if (x1 > n || x2 > n || y1 > m || y2 > m || dp1[x1][y1] || dp2[x2][y2] || x1 == x2) {
        return 0;
    }
    if (dp[x1][y1][x2] != -1) {
        return dp[x1][y1][x2];
    }
    dp[x1][y1][x2] = ((ll) rec(x1 + 1, y1, x2 + 1) + rec(x1 + 1, y1, x2) +
                      rec(x1, y1 + 1, x2 + 1) + rec(x1, y1 + 1, x2)) % mod;
    return dp[x1][y1][x2];
}

void solve() {
    int k;
    cin >> n >> m >> k;
    --n, --m;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            for (int i1 = 0; i1 <= n; ++i1) {
                dp[i][j][i1] = -1;
            }
        }
    }
    dp[n][m - 1][n - 1] = 1;
    for (int t = 0; t < k; ++t) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (x == 0 && y == 0) {
            continue;
        }
        if (x == n && y == m) {
            continue;
        }
        for (int i = 0; i <= x - 1; ++i) {
            for (int j = y + 1; j <= m; ++j) {
                dp1[i][j] = 1;
            }
        }
        for (int i = x + 1; i <= n; ++i) {
            for (int j = 0; j <= y - 1; ++j) {
                dp2[i][j] = 1;
            }
        }
        for (int i = x + 1; i <= n; ++i) {
            for (int j = 0; j <= y - 1; ++j) {
                for (int i1 = 0; i1 <= x - 1; ++i1) {
                    int j1 = i + j - i1;
                    if (y + 1 <= j1 && j1 <= m) {
                        dp[i][j][i1] = 0;
                    }
                }
            }
        }
    }
    cout << 2 * rec() % mod;
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
