#include<bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
using ll = long long;
using ld = long double;
const int N = 1e1, mod = 1e9 + 7;
int n, m, k;
int dp[N][N];

int rec(int x1, int y1, int x2, int y2,int k1 = 0) {
    if (x1 > n || x2 > n || y1 > m || x1 == x2) {
        return 0;
    }
    k1 += dp[x1][y1] + dp[x2][y2];
    if (x1 == n && y1 == m - 1 && x2 == n - 1 && y2 == m) {
        return k1 == k;
    }
    int h1 = rec(x1 + 1, y1, x2 + 1, y2, k1);
    int h2 = rec(x1 + 1, y1, x2, y2 + 1, k1);
    int h3 = rec(x1, y1 + 1, x2 + 1, y2, k1);
    int h4 = rec(x1, y1 + 1, x2, y2 + 1, k1);
    int ans = (h1 + h2 + h3 + h4) % mod;
    return ans;
}

void solve() {
    cin >> n >> m >> k;
    --n, --m;
    int k1 = 0;
    for (int t = 0; t < k; ++t) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (x == 0 && y == 0) {
            ++k1;
            continue;
        }
        if (x == n && y == m) {
            ++k1;
            continue;
        }
        if (dp[x][y]) {
            ++k1;
        }
        dp[x][y] = 1;
    }
    k -= k1;
    cout << 2 * rec(1, 0, 0, 1) % mod;
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
