#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
using ll = long long;
using ld = long double;
typedef tree<pair<int,int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int mod = 1e9 + 7;
vector<pair<int,int> > dp, dp1;
vector<int> d[8];
int g[8][8];
int k;

pair<int,int> f(int mask) {
    int ans = 0, sm = 0;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k - i - 1; ++j) {
            if ((mask >> g[i][j]) & 1) {
                ++sm;
                ans ^= (1 << g[i + 1][j]);
            }
        }
    }
    return {ans, sm};
}

void solve() {
    int n;
    cin >> n >> k;
    for (int mask = 0; mask < (1 << k); ++mask) {
        int sm = 0;
        for (int i = 0; i < k; ++i) {
            if ((mask >> i) & 1) {
                ++sm;
            }
        }
        d[sm].emplace_back(mask);
    }
    int sm1 = 0;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j <= k - i - 1; ++j) {
            g[i][j] = sm1++;
        }
    }
    dp.emplace_back(0, 1);
    for (int t = 0; t < n; ++t) {
        int s;
        cin >> s;
        for (auto [mask,kol]: dp) {
            auto [mask1, sm] = f(mask);
            if (s - sm >= 0 && s - sm <= 7) {
                for (auto m : d[s - sm]) {
                    dp1.emplace_back(mask1 ^ m, kol);
                }
            }
        }
        dp.clear();
        sort(dp1.begin(), dp1.end());
        for (auto [mask,kol]: dp1) {
            if (dp.empty() || dp.back().first != mask) {
                dp.emplace_back(mask, kol);
            } else {
                dp.back().second = (dp.back().second + kol) % mod;
            }
        }
        swap(dp, dp1);
        dp1.clear();
    }
    int ans = 0;
    for (auto [it,kol]: dp) {
        ans = (ans + kol) % mod;
    }
    cout << ans;
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
