#include<bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
using ll = long long;
using ld = long double;
const int N = 1e5;
vector<int> a[N];
vector<int> dp[N + 1], dp1[N + 1];
int m[N];

void solve() {
    int n, s;
    cin >> n >> s;
    for (int i = 0; i <= n; ++i) {
        dp[i].resize(s + 1);
        dp1[i].resize(s + 1);
    }
    for (int i = 0; i < n; ++i) {
        cin >> m[i];
        a[i].resize(m[i]);
        for (int j = 0; j < m[i]; ++j) {
            cin >> a[i][j];
        }
    }
    dp[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m[i]; ++j) {
            for (int s1 = s; s1 >= a[i][j]; --s1) {
                if (dp[i + 1][s1] == 0) {
                    if (dp[i][s1 - a[i][j]]) {
                        dp1[i + 1][s1] = j + 1;
                        dp[i + 1][s1] = 1;
                    } else if (dp[i + 1][s1 - a[i][j]]) {
                        dp[i + 1][s1] = 1;
                        dp1[i + 1][s1] = -j - 1;
                    }
                }
            }
        }
    }
    if (dp[n][s] == 0) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    int i = n, s1 = s;
    vector<vector<int> > ans;
    while (i != 0) {
        ans.emplace_back();
        int i1 = i;
        while (i1 == i) {
            int pos = dp1[i][s1];
            if (pos >= 1) {
                --pos;
                ans.back().emplace_back(pos);
                s1 -= a[i - 1][pos];
                --i;
            } else {
                pos = -(pos + 1);
                ans.back().emplace_back(pos);
                s1 -= a[i - 1][pos];
            }
        }
    }
    reverse(ans.begin(), ans.end());
    for (i = 0; i < n; ++i) {
        reverse(ans[i].begin(), ans[i].end());
        cout << (int) ans[i].size() << '\n';
        for (auto it: ans[i]) {
            cout << it + 1 << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
