#include<bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

// #define int long long
using ll = long long;
using ld = long double;
const int N = 1e6, mod = 1e9 + 7;
int n, m, k;
unordered_map<ll, int> dp[N];

int rec(int x1 = 1, int y1 = 0, int x2 = 0) {
    int y2 = x1 + y1 - x2;
    if (x1 > n || x2 > n || y1 > m || y2 > m || x1 == x2) {
        return 0;
    }
    auto iter = dp[x1].find((ll) y1 << 32 + x2);
    if (iter != dp[x1].end()) {
        return iter->second;
    }
    int h = ((ll) rec(x1 + 1, y1, x2 + 1) + rec(x1 + 1, y1, x2) +
             rec(x1, y1 + 1, x2 + 1) + rec(x1, y1 + 1, x2)) % mod;
    dp[x1][(ll) y1 << 32 + x2] = h;
    return h;
}

void solve() {
    cin >> n >> m >> k;
    if (k == 0) {
        --n, --m;
        dp[n][(ll) (m - 1) << 32 + (n - 1)] = 1;
        cout << 2 * rec() % mod;
    }
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
