#include<bits/stdc++.h>
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(18) << fixed;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
using ll = long long;
using ld = long double;
const int N = 1e1, mod = 1e9 + 7;
int dp[N][N][N][N], n, m;
int dp1[N][N], dp2[N][N];

int rec(int x1,int y1,int x2,int y2) {
    if (x1 > n || x2 > n || y1 > m || y2 > m || dp1[x1][y1] || dp2[x2][y2]) {
        return 0;
    }
    if (dp[x1][y1][x2][y2] != -1) {
        return dp[x1][y1][x2][y2];
    }
    int h1 = rec(x1 + 1, y1, x2 + 1, y2);
    int h2 = rec(x1 + 1, y1, x2, y2 + 1);
    int h3 = rec(x1, y1 + 1, x2 + 1, y2);
    int h4 = rec(x1, y1 + 1, x2, y2 + 1);
    dp[x1][y1][x2][y2] = (h1 + h2 + h3 + h4) % mod;
    return dp[x1][y1][x2][y2];
}

void solve() {
    int k;
    cin >> n >> m >> k;
    --n, --m;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            for (int i1 = 0; i1 <= n; ++i1) {
                for (int j1 = 0; j1 <= m; ++j1) {
                    dp[i][j][i1][j1] = -1;
                }
            }
        }
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            dp[i][j][i][j] = 0;
        }
    }
    dp[n][m - 1][n - 1][m] = 1;
    for (int t = 0; t < k; ++t) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (x == 0 && y == 0) {
            continue;
        }
        if (x == n && y == m) {
            continue;
        }
        for (int i = 0; i <= x - 1; ++i) {
            for (int j = y + 1; j <= m; ++j) {
                dp1[i][j] = 1;
            }
        }
        for (int i = x + 1; i <= n; ++i) {
            for (int j = 0; j <= y - 1; ++j) {
                dp2[i][j] = 1;
            }
        }
        for (int i = x + 1; i <= n; ++i) {
            for (int j = 0; j <= y - 1; ++j) {
                for (int i1 = 0; i1 <= x - 1; ++i1) {
                    for (int j1 = y + 1; j1 <= m; ++j1) {
                        dp[i][j][i1][j1] = 0;
                    }
                }
            }
        }
    }
    cout << 2 * rec(1, 0, 0, 1);
}

signed main() {
    fast_in_out();
    int qwe = 1;
    // cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
